Index: layouts.html
===================================================================
--- layouts.html	(revision 1701)
+++ layouts.html	(working copy)
@@ -1414,8 +1414,12 @@
 
    	<a name="ClassicHTMLLayout"></a>
 
-		<h3>HTMLLayout</h3>
+		<h2>Generating logs in HTML format</h2>
 		
+    <p>Logback provides a special <a
+    href="../xref/ch/qos/logback/core/Layout.html"><code>Layout</code></a>
+    to generate logs directly in HTML format.</p>
+
     <p><a href="../xref/ch/qos/logback/classic/html/HTMLLayout.html">
     <code>HTMLLayout</code></a> outputs logging events in an HTML
     table where each row of the table corresponds to a logging
@@ -1438,9 +1442,10 @@
 		<code>PatternLayout</code> with <code>HTMLLayout</code> is that
 		conversion specifiers should not be separated by space characters
 		or more generally by literal text. Each specifier found in the
-		pattern willa result in a separate column, in particular for each
-		literal text in the pattern, wasting valuable real estate on your
-		screen.
+		pattern will result in a separate column.
+		Likewise a separate column will be generated for each block of
+		literal text found in the pattern potentially wasting valuable
+		real estate on your screen.
     </p>
 
     <p>Here is simple but functional configuration file illustrating
@@ -1492,13 +1497,13 @@
 		traces, a table column will be created to display exception stack
 		traces. In most cases the column will be empty, wasting screen
 		real-estate. Moreover, printing a stack trace on a separate column
-		does yield very readable results. Fortunately, the <em>%ex</em>
+		does not yield very readable results. Fortunately, the <em>%ex</em>
 		conversion word is not the only way to display stack traces.
 		</p>
 
 		<p>A better solution is available through implementations of
 		<code>IThrowableRenderer</code> interface.  Such an implementation
-		can assigned to <code>HTMLLayout</code> to manage the display data
+		can be assigned to <code>HTMLLayout</code> to manage the display of data
 		related to exceptions. By default, a
 		<a href="../xref/ch/qos/logback/classic/html/DefaultThrowableRenderer.html">
 			<code>DefaultThrowableRenderer</code></a> is assigned to each
@@ -1513,7 +1518,7 @@
 			<code>NOPThrowableRenderer</code></a> in the configuration file
 			in order to disable displaying a separate row for the stack
 			trace. We don't have the faintest idea why you would want to do
-			that, but if you did, you could.
+			that, but if you wished, you could.
 		</p>
 
     <h3>CSS</h3>
@@ -1522,8 +1527,8 @@
     is controlled through a Cascading Style Sheet (CSS). In the
     absence of specific instructions, <code>HTMLLayout</code> will
     default to its internal CSS. However, your can instruct
-    <code>HTMLLayout</code> you use an external CSS file. For this
-    purpose, a <code>cssBuilder</code> element can be nested within a
+    <code>HTMLLayout</code> to use an external CSS file. For this
+    purpose a <code>cssBuilder</code> element can be nested within a
     <code>&lt;layout&gt;</code> element, as shown below.
 		</p>
 
@@ -1602,9 +1607,10 @@
 		<h3>PatternLayout</h3>
 		<p> <a href="../xref/ch/qos/logback/access/PatternLayout.html">
 		<code>PatternLayout</code></a> in logback-access can be configured
-		in the same way as it's classic counterpart, with the notable
-		exception of the available conversion specifiers, as appropriate
-		for HTTP servlet request and response.
+		much in the same way as its classic counterpart. However it
+		additionally features a number of conversion specifiers
+		logging particular bits of information
+		on HTTP servlet request and response.
 		</p>
 
 		<p>Below is a list of conversion specifiers for 
@@ -1887,7 +1893,7 @@
 	 	which displays client host, remote log name, user, date, requested URL, status code 
 	 	and response's content length</p>
 	 	
-	 	<p>The <em>combined</em> keyword is a shortcut to 
+	 	<p>The <em>combined</em> keyword is a shortcut for
 	 	<em>%h %l %u %t \"%r\" %s %b \"%i{Referer}\" \"%i{User-Agent}\"</em>. This pattern begins
 	 	much like the <em>common</em> pattern but also displays two request headers, namely
 	 	 referer, and user-agent.</p>
@@ -1898,11 +1904,10 @@
 		<p>The <a
 		href="../xref/ch/qos/logback/access/html/HTMLLayout.html"><code>HTMLLayout</code></a>
 		class found in logback-access is similar to the <a
-		href="#ClassicHTMLLayout"><code>HTMLLayout</code></a> class found
-		in logback-classic.
+		href="#ClassicHTMLLayout"><code>HTMLLayout</code></a> class from logback-classic.
     </p>
 		
-		<p>By default, it will create a table containing the following data:</p>
+		<p>By default it will create a table containing the following data:</p>
 		
 		<ul>
 			<p>Remote IP</p>
@@ -1915,19 +1920,19 @@
 		<p>Here is a sample output produced by <code>HTMLLayout</code> in logback-access:</p>
 		<img src="images/htmlLayoutAccess.gif" alt="Access HTML Layout Sample Image"/>
 
-		<p>What is better than a real world example? Our own log4j
-		properties to logback <a
-		href="http://logback.qos.ch/translator/">translator</a> makes use
-		of logback-access to showcase a live ouput, using a
-		<code>RollingFileAppender</code> and <code>HTMLLayout</code>.</p>
+		<p>What can be better than a real world example? Our own log4j
+		properties for logback <a
+		href="http://logback.qos.ch/translator/">translator</a> make use
+		of logback-access to demonstrate live ouput from
+		<code>RollingFileAppender</code> with <code>HTMLLayout</code>.</p>
 		
 		<p>You can see the file by <a
 		href="http://logback.qos.ch/translator/logs/access.html">following
 		this link</a>.</p>
 
-		<p>Just like any access log, each visit the <a
+		<p>Just like any access log the <a
 		href="http://logback.qos.ch/translator/">translator</a>
-		web-application will add a new entry to the access logs.
+		web-application adds a new access log entry on each user request.
     </p>
 
 <script src="../templates/footer.js"></script>